<template>
    <v-card>
        <v-card-title class="indigo darken-2 white--text">
            {{ $t('general') }}
        </v-card-title>
        <v-list>
            <v-list-item>
                <v-list-item-content>
                    <v-list-item-subtitle>{{ $t('total_', [$tc('order', 2)]) }}</v-list-item-subtitle>
                </v-list-item-content>
                <v-list-item-content class="py-0">
                    <v-skeleton-loader
                        :loading="fetchingGeneral"
                        type="list-item"
                    >
                        <v-list-item-subtitle class="text-right">{{ totalOrder }}</v-list-item-subtitle>
                    </v-skeleton-loader>
                </v-list-item-content>
            </v-list-item>

            <v-divider></v-divider>

            <v-list-item>
                <v-list-item-content>
                    <v-list-item-subtitle>{{ $t('total_', [$tc('sales')]) }}</v-list-item-subtitle>
                </v-list-item-content>
                <v-list-item-content class="py-0">
                    <v-skeleton-loader
                        :loading="fetchingGeneral"
                        type="list-item"
                    >
                        <v-list-item-subtitle class="text-right">MYR {{ totalSales | currency('0.0a') }}</v-list-item-subtitle>
                    </v-skeleton-loader>
                </v-list-item-content>
            </v-list-item>

            <v-divider></v-divider>

            <v-list-item>
                <v-list-item-content>
                    <v-list-item-subtitle>{{ $t('member_since') }}</v-list-item-subtitle>
                </v-list-item-content>
                <v-list-item-content class="py-0">
                    <v-skeleton-loader
                        :loading="fetchingGeneral"
                        type="list-item"
                    >
                        <v-list-item-subtitle class="text-right">{{ memberSince | date('Do MMM YYYY') }}</v-list-item-subtitle>
                    </v-skeleton-loader>
                </v-list-item-content>
            </v-list-item>

            <v-divider></v-divider>

            <v-list-item>
                <v-list-item-content>
                    <v-list-item-subtitle>{{ $t('subscribed') }}</v-list-item-subtitle>
                </v-list-item-content>
                <v-list-item-content class="py-0">
                    <v-skeleton-loader
                        :loading="fetchingGeneral"
                        type="list-item"
                    >
                        <v-list-item-subtitle class="text-right">{{ subscribed ? subscribed.plan.name : $t('na') }}</v-list-item-subtitle>
                    </v-skeleton-loader>
                </v-list-item-content>
            </v-list-item>

            <v-divider></v-divider>

            <v-list-item>
                <v-list-item-content>
                    <v-list-item-subtitle>{{ $t('next_cycle') }}</v-list-item-subtitle>
                </v-list-item-content>
                <v-list-item-content class="py-0">
                    <v-skeleton-loader
                        :loading="fetchingGeneral"
                        type="list-item"
                    >
                        <v-list-item-subtitle class="text-right">{{ nextBillingCycle | date('Do MMM YYYY') }}</v-list-item-subtitle>
                    </v-skeleton-loader>
                </v-list-item-content>
            </v-list-item>
        </v-list>

        <v-divider></v-divider>

        <template v-if="!fetchingWishlist">
            <v-list subheader>
                <v-subheader>{{ $tc('wishlist', 2) }}</v-subheader>
                <v-list-item v-for="item in wishlist.items" :key="item.id">
                    <v-list-item-content>
                        <v-list-item-avatar
                            tile
                            height="120"
                        >
                            <v-img :src="item.product.images[0].url"></v-img>
                        </v-list-item-avatar>
                    </v-list-item-content>
                    <v-list-item-content class="py-0">
                        <v-list-item-subtitle class="text-right">{{ item.product.name }}</v-list-item-subtitle>
                    </v-list-item-content>
                </v-list-item>
            </v-list>
        </template>

        <div
            v-else
            class="d-flex justify-center align-center wishlist-loader"
        >
            <v-progress-circular indeterminate color="primary"></v-progress-circular>
        </div>
    </v-card>
</template>

<script>
    import { mapMutations } from "vuex";

    export default {
        name: 'UserGeneral',
        props: ['id'],
        data: () => ({
            fetchingGeneral: false,
            fetchingWishlist: false,
            memberSince: null,
            totalOrder: 0,
            totalSales: 0,
            subscribed: {
                plan: {
                    name: ''
                }
            },
            nextBillingCycle: null,
            wishlist: {
                items: []
            }
        }),
        created() {
            this.fetchGeneral();
            this.fetchWishlist();
        },
        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            fetchGeneral() {
                this.fetchingGeneral = true;

                axios.get(`api/accounts/${this.id}/general`)
                    .then(({ data }) => {
                        this.totalOrder = data.total_order;
                        this.totalSales = data.total_sales;
                        this.memberSince = data.created_at;
                        this.subscribed = data.subscribed;
                        this.nextBillingCycle = data.next_billing_cycle;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.fetchingGeneral = false;
                    })
            },

            fetchWishlist() {
                this.fetchingWishlist = true;

                axios.get(`api/accounts/${this.id}/wishlists`)
                    .then(({ data }) => {
                        this.wishlist = data;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.fetchingWishlist = false;
                    })
            }
        }
    }
</script>

<style scoped>
    .wishlist-loader {
        min-height: 120px;
    }
</style>
